! -*- F90 -*-
     program mpitest
       implicit none
       include 'mpif.h'
       integer :: status(MPI_STATUS_SIZE)
       
       integer :: ierr,itag,idum,i,iother
       real*8 :: cputotal,cptime,cptdum
! start the parallelization
       call MPI_Init(mpierror)
       call MPI_Comm_size(MPI_COMM_WORLD, mpisize, mpierror)
       if (mpisize.gt.mpimax) then
        write(6,*) ' we allow maximally ',mpimax,' processes '
        write(6,*) ' but you asked for ',mpisize,' processes '
        stop
       end if
       call MPI_Comm_rank(MPI_COMM_WORLD, mpirank, mpierror)
!-----------------------------------
! this is the initialization of the data, to be executed once
! in fact, every process does the same initialization, but only 
! the first process prints something
!
       if (mpirank.eq.0) then
        write(6,*) ' Master process ',mpirank+1,'/',mpisize
        call system(' echo "  Master execution host is : `hostname`"')
        call dating('MPI TEST',1)
        call header
!       call flush()
! close the first printing section
        itag=1
        do iother=1,mpisize-1
         call mpi_send(idum,1,MPI_INTEGER,iother,itag &
              ,MPI_COMM_WORLD,ierr)
        end do
       else
        itag=1
        call mpi_recv(idum,1,MPI_INTEGER,0,itag &
             ,MPI_COMM_WORLD,status,ierr)
        write(6,*) ' process ',mpirank+1,'/',mpisize
        call system(' echo "  execution host is : `hostname`"') 
       end if

       call mpi_barrier(MPI_COMM_WORLD,ierr)
       
       IF (MPIRANK.NE.0) then
        CPTDUM=CPTIME(1)
        itag=27
        call mpi_send(CPTDUM,1,MPI_DOUBLE_PRECISION,0,itag &
             ,MPI_COMM_WORLD,ierr)
        itag=28
       else
        CPUT_PROCESS(0)=CPTIME(1)
        CPUTOTAL=CPUT_PROCESS(0)
        do i=1,mpisize-1
         itag=27
         call mpi_recv(CPTDUM,1,MPI_DOUBLE_PRECISION,i,itag &
              ,MPI_COMM_WORLD,status,ierr)
         CPUT_PROCESS(I)=CPTDUM
         CPUTOTAL=CPUTOTAL+CPUT_PROCESS(I)
         itag=28
        end do
       end if
       
       call MPI_Finalize(mpierror)
       
       if (mpirank.eq.0) then
        do i=0,mpisize-1
         WRITE(6,9654) i+1,cput_process(i)
        end do
        WRITE(6,9655) cputotal
9654    format('  CPU-time spent on process No ',i4,' is ',F12.3,' sec')
9655    format(1X,70('-') &
             ,/,'  Total accumulated cputime is ',F20.3,' sec')
        call dating('MPI TEST',2)
       end if
       
     end program ozosim_par
     
     subroutine header
       write(6,*)
       write(6,*) ' ---------------------------------------- ' 
       write(6,*) '    MPI test program '
       write(6,*)
       write(6,*) '    P. Reinhardt 6/2015 using IRP '
       write(6,*) ' ---------------------------------------- ' 
       write(6,*)
     end subroutine header
     
